<template>
  <div class="gris">
    <v-row class="mb-6" justify="center" no-gutters>
      <v-col lg="2"> </v-col>
      <v-col md="auto">
        <v-sheet>
          <v-slide-group multiple show-arrows class="ma-0">
            <v-slide-item
              v-for="(valor, index) in objetoFinal"
              :key="index"
              class="pa-5 ma-0"
            >
              <CardAgrupadorRegional :objetoParametro="valor" />
            </v-slide-item>
          </v-slide-group>
        </v-sheet>
      </v-col>
      <v-col lg="2"> </v-col>
    </v-row>
  </div>
</template>

<script>
import store from "@/store";
const periodoSupervisionMtto = store.state.periodoSupervisionMtto;
import axios from "axios";
import CardAgrupadorRegional from "./CardAgrupadorRegional.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  components: { CardAgrupadorRegional },
  name: "slider_component_regional",
  data() {
    return {
      user: { empleado: 0, nombre: "" },

      colores: ["#ff0000", "#ffcd00", "#19d228"],
      rangos: ["0,50", "51,89", "90,100"],
      fechaTrimestral: null,
      fechaInicioFinTrimesreal: null,
      fechaInicioFinAldia: null,

      periodo: {},
      objetoFinal: [],

      servicioTerritorios: {
        contador: 1,
        objeto: null,
      },
      servicioConteoInicioFinTrimestral: {
        contador: 1,
        objeto: null,
      },
      servicioConteoInicioFinAldia: {
        contador: 1,
        objeto: null,
      },
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    seteaDatos(
      fechaTrimestral,
      fechaInicioFinTrimesreal,
      fechaInicioFinAldia,
      rangos,
      colores,
      user
    ) {
      this.user = user;
      this.fechaTrimestral = fechaTrimestral;
      this.fechaInicioFinTrimesreal = fechaInicioFinTrimesreal;
      this.fechaInicioFinAldia = fechaInicioFinAldia;
      this.rangos = rangos;
      this.colores = colores;
      this.inicializaContadorServicio();
      this.getTerritorios();
      this.getServicios();
    },
    inicializaContadorServicio() {
      this.servicioTerritorios.contador = 1;
      this.servicioConteoInicioFinTrimestral.contador = 1;
      this.servicioConteoInicioFinAldia.contador = 1;
    },
    validaServiciosEjecutados() {
      if (
        this.servicioTerritorios.contador == 0 &&
        this.servicioConteoInicioFinTrimestral.contador == 0 &&
        this.servicioConteoInicioFinAldia.contador == 0
      ) {
        this.generadorObjeto();
      }
    },
    generadorObjeto() {
      var objeto, inicioFinTrimestral, inicioFinAldia;
      var lista = new Map();

      for (var i = 0; i < this.servicioTerritorios.objeto.length; i++) {
        if (this.servicioTerritorios.objeto[i].idJefeZona == this.user.empleado) {
          if (!lista.get(this.servicioTerritorios.objeto[i].zona)) {
            lista.set(this.servicioTerritorios.objeto[i].zona, []);
          }
          if (this.servicioConteoInicioFinTrimestral.objeto != undefined) {
            inicioFinTrimestral = this.servicioConteoInicioFinTrimestral.objeto.find(
              (valor) =>
                valor.idTerritorio == this.servicioTerritorios.objeto[i].idTerritorio
            );
            inicioFinAldia = this.servicioConteoInicioFinAldia.objeto.find(
              (valor) =>
                valor.idTerritorio == this.servicioTerritorios.objeto[i].idTerritorio
            );
          } else {
            inicioFinTrimestral = undefined;
            inicioFinAldia = undefined;
          }
          if (inicioFinTrimestral == undefined) {
            inicioFinTrimestral = {
              conteoProgramadas: 0,
              conteoRealizadas: 0,
            };
          }
          if (inicioFinAldia == undefined) {
            inicioFinAldia = {
              conteoProgramadas: 0,
              conteoRealizadas: 0,
            };
          }

          objeto = [
            {
              territorio: this.servicioTerritorios.objeto[i].territorio,
              idTerritorio: this.servicioTerritorios.objeto[i].idCeco,
              responsable: this.servicioTerritorios.objeto[i].nombreResponsable,
              nombreJefeZona: this.servicioTerritorios.objeto[i].nombreJefeZona,

              to: {
                name: "supervision_mantenimiento_dashboard_territorio_regional",
                params: {
                  parametros: this.serviceCommons.objectToBase64({
                    responsable: this.servicioTerritorios.objeto[i].nombreResponsable,
                    territorio: this.servicioTerritorios.objeto[i].territorio,
                    idTerritorio: this.servicioTerritorios.objeto[i].idCeco,
                    fechaInicio: this.fechaInicioFinTrimesreal.fechaInicio,
                    fechaFin: this.fechaInicioFinTrimesreal.fechaFin,
                    valueTrimestre: inicioFinTrimestral.conteoRealizadas,
                    targetTrimestre: inicioFinTrimestral.conteoProgramadas,
                    valueAldia: inicioFinAldia.conteoRealizadas,
                    targetAldia: inicioFinAldia.conteoProgramadas,
                    rangoSemanas: JSON.stringify(
                      this.fechaInicioFinTrimesreal.rangoSemanas
                    ),
                    rangos: JSON.stringify(this.rangos),
                    colores: JSON.stringify(this.colores),
                  }),
                },
              },
              objectoInicioFinTrimestral: {
                value: inicioFinTrimestral.conteoRealizadas,
                programadasAlDia: inicioFinAldia.conteoProgramadas,
                programadasAlTrimestre: inicioFinTrimestral.conteoProgramadas,
                id_name:
                  "altrimestre_" +
                  this.servicioTerritorios.objeto[i].territorio.replaceAll(" ", ""),
                texto: "Realizado al\ndía de hoy",
                colores: this.colores,
                rangos: this.rangos,
              },
              objectoInicioFinAldia: {
                value: inicioFinAldia.conteoRealizadas,
                programadasAlDia: inicioFinAldia.conteoProgramadas,
                programadasAlTrimestre: inicioFinTrimestral.conteoProgramadas,
                id_name:
                  "aldia_" +
                  this.servicioTerritorios.objeto[i].territorio.replaceAll(" ", ""),
                texto: "Realizado al\ndía de hoy",
                colores: this.colores,
                rangos: this.rangos,
              },
            },
          ];
          var valorAgrupador = lista.get(this.servicioTerritorios.objeto[i].zona);
          valorAgrupador.push(objeto);
          lista.set(this.servicioTerritorios.objeto[i].zona, valorAgrupador);

          //objetoFinal = objetoFinal.concat(objeto);
        }
      }
      /*
      objetoFinal.sort(function (a, b) {
        let porcentajeA = Math.round(
          (a.objectoInicioFinAldia.value * 100) / a.objectoInicioFinAldia.programadasAlDia
        );
        let porcentajeB = Math.round(
          (b.objectoInicioFinAldia.value * 100) / b.objectoInicioFinAldia.programadasAlDia
        );
        if (porcentajeA > porcentajeB) {
          return 1;
        }
        if (porcentajeA < porcentajeB) {
          return -1;
        }
        // a must be equal to b
        return 0;
      });
      */
      this.objetoFinal = Array.from(lista, ([name, value]) => ({
        name,
        value,
      }));
      this.objetoFinal.map((itemZ) => {
        var value = 0;
        var programadasAlDia = 0;
        var programadasAlTrimestre = 0;
        var objetoZona = JSON.parse(
          JSON.stringify(itemZ.value[0][0].objectoInicioFinTrimestral)
        );
        itemZ.value.map((item) => {
          value += item[0].objectoInicioFinTrimestral.value;
          programadasAlDia += item[0].objectoInicioFinTrimestral.programadasAlDia;
          programadasAlTrimestre +=
            item[0].objectoInicioFinTrimestral.programadasAlTrimestre;
        });
        objetoZona.value = value;
        objetoZona.programadasAlDia = programadasAlDia;
        objetoZona.programadasAlTrimestre = programadasAlTrimestre;
        objetoZona.id_name = "idZonaGrafica_" + itemZ.name.replaceAll(" ", "");

        itemZ.objectoInicioFinTrimestralZona = objetoZona;
      });
    },

    getTerritorios() {
      //
      let url1 = "/asignacion-mtto/secure/get/geografia";
      axios
        .post(url1, { territorio: null })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                console.log("geografia\n" + JSON.stringify(data));
                this.servicioTerritorios.contador = this.servicioTerritorios.contador - 1;
                this.servicioTerritorios.objeto = data;
                this.validaServiciosEjecutados();
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },

    getServicios() {
      //
      let url1 = "/asignacion-mtto/secure/get/conteoGeneralTerritorio";
      axios
        .post(url1, this.fechaInicioFinTrimesreal)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              console.log(
                "fechaInicioFinTrimesreal, conteoGeneralTerritorio \n" +
                  JSON.stringify(data)
              );
              this.servicioConteoInicioFinTrimestral.contador =
                this.servicioConteoInicioFinTrimestral.contador - 1;
              this.servicioConteoInicioFinTrimestral.objeto = null;
              this.servicioConteoInicioFinTrimestral.objeto = data;
              this.validaServiciosEjecutados();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});

      axios
        .post(url1, this.fechaInicioFinAldia)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              console.log(
                "fechaInicioFinAldia, conteoGeneralTerritorio \n" + JSON.stringify(data)
              );
              this.servicioConteoInicioFinAldia.contador =
                this.servicioConteoInicioFinAldia.contador - 1;
              this.servicioConteoInicioFinAldia.objeto = null;
              this.servicioConteoInicioFinAldia.objeto = data;
              this.validaServiciosEjecutados();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
  },
  mounted() {},
  created() {
    this.periodo = periodoSupervisionMtto;
  },
};
</script>
